; cga160.pas: shows CGA 160x100x16 "graphics" mode
; assembly language variant for use with nasm - by Eric Auer 3/2001

bits 16
segment .text
org 256

	call setmode	; init CGA 160x100 mode !
	call pattern	; draw some really boring pattern :-)
; *** ente:
; ***	mov ax,1	; wait for a key, then go back to text mode and exit
; ***	int 16h
; ***	jz ente		;	WARNING: This may be wrong, I am writing this 
	mov ax,3	; 	wait for key stuff without having Intlist here.
	int 10h
	mov ax,500h
	int 10h
	mov ax,4c00h
	int 21h

; -------------------------------------------------------------

setmode:		; starts CGA 160x100x16 mode from ?0x25 text mode
	push es
	push ax
	push cx
	push dx
	push si
	push di
	mov dx,[modus]
	mov al,1
	out dx,al	; turn off GFX#
	cld
	mov si,cga6854
	mov cx,10	; 12/2002: must be 10, sigh...
	xor ax,ax
setloop:
	mov dx,[regs6854]
	mov al,ah
	out dx,al
	lodsb
	inc dx
	out dx,al
	inc ah
	loop setloop
	mov ax,0b800h
	mov es,ax
	push ds
	mov ax,0ba00h
	mov ds,ax
	mov ax,221	; special cls because CGA 160 is almost text...
			; <- 221, not 222 9/01 (221 is 1/2 block, left
			;    half filled and right half background)
	mov cx,1000h
	xor di,di
clsloop1:
	stosw
	mov [ds:di],ax
	loop clsloop1
	pop ds
	mov dx,[modus]
	mov al,13	; 13, see below ************************
	out dx,al	; GFX on, now in CGA 160x100x16 mode!
	pop di
	pop si
	pop dx
	pop cx
	pop ax
	pop es
	ret

; -------------------------------------------------------------
			
cga_pset:	; sets a pixel, give color in al, X in bx and Y in cx
	push ds
	push ax
	push bx
	push cx
	push dx
; ***		shr cx,2	; squeeze to 160x25 if text mode
	mov dx,0b800h
	mov ds,dx
	and al,0fh	; do
	and bx,0ffh	; some
	and cx,07fh	; sanitizing
	push ax
	mov ax,160
	mul cx
	mov cx,ax	; cx is our (160*y)
	mov ax,bx
	or  bx,1	; CGA 160 is similar to a text mode here!
	add bx,cx	; this is our pointer: (160 * y) + (x or 1)
	test ax,1	; even/odd difference
	pop ax		; the color
	mov ah,[bx]	; old value
	jz cga_odd
cga_even:
	mov cl,4
	shl al,cl
	and ah,0fh
	jmp short cga_wr
cga_odd:
	and ah,0f0h
cga_wr:
	or al,ah
	mov [bx],al	; write modified value
	pop dx
	pop cx
	pop bx
	pop ax
	pop ds
	ret

pattern:
	push ax
	push bx
	push cx
	push dx
	push si
	push di
	xor si,si	; SI is color, 1 to 15
	inc si
color_loop:
	mov di,5	; DI is size, 5 to (14*3)+5 step 3
size_loop:
	mov dx,1	; DX is count
count_loop:
	mov ax,si	; chose color
	xor ax,di	; <- add a little color 9/01
	and ax,0fh	; <- as above
	jnz visible	; <- as above
	inc ax		; <- as above
visible:
	mov bx,80
	sub bx,di
	mov cx,50
	sub cx,di
	add cx,dx	; cga_pset: bx is x, cx is y, al is color...
	call cga_pset	; x 80-size, y 50-size+count (left, line dn.)
	mov bx,80
	add bx,di	
	call cga_pset	; x 80+size, y as above (right, line down)
	mov bx,80
	sub bx,di
	add bx,dx
	mov cx,50
	sub cx,di
	call cga_pset	; x 80-size+count, y 50-size (above, line r.)
	mov cx,50
	add cx,di	; <- DI not DX 9/01
	call cga_pset	; x as above, y 50+size (below, line right)

	inc dx		; next 4 pixels in rectangle
	push ax
	mov ax,di	; <- DI not DX 9/01
	add ax,di
	cmp dx,ax	; count less than size+size ?
	pop ax
	jb count_loop
	add di,3	; next indexa
	cmp di,14+14+14+5
	jb size_loop

	mov cx,4	; <- new 9/01: wait some time
ticker:
	call tictac	; <- as above
	dec cx		; <- as above
	jnz ticker	; <- as above

	inc si		; next color
	and si,0fh	; <- 15, not not 15 9/01
	or si,si
	jnz color_loop

	pop di
	pop si
	pop dx
	pop cx
	pop bx
	pop ax
	ret

; -------------------------------------------------------------

tictac:			; 9/01 timer based on int 08 (irq 0) counter
	push ds
	push ax
	pushf
	sti
	xor ax,ax
	mov ds,ax
	mov al,[46ch]	; time
	inc ax		; wait up to 1/18.2 sec
tick:	
	cmp al,[46ch]
	jnz tick	; should we miss it, max penalty 255/18.2 sec
	popf
	pop ax
	pop ds
	ret

; -------------------------------------------------------------

cga6854		db 93,80,90,10, 127,6,100,112, 0,1
; similar to graphics mode on one hand,
; but interleave mode 0 instead of 2 is very special and
; will lead to "80*2" x 100 mode, kind of textish mode
;
; register names and text/graphics (gra. only listed if different
; to text) normal values:
;
; *hchar*(113/56) hcharview(_80_/40) hcharsync(_90_/45) hsyncsize(_10_)
; vchar(31/_127_) vadjust(_6_) vview(25/_100_) vsync(28/_112_)
; *interleave*(2) charheight(7/_1_)
;
modus 		dw 3d8h
; mode 1 while resetting, mode 13/0d for cga 160x100,
; meaning x x blink=0 640x200=0
;   enable=1 *monochrome*=1 *graphics*=0 wide80=1
;
regs6854 	dw 3d4h
; data6854 	dw 3d5h
