{$R-}{$D+}{$L+} {For Debugging}
unit eavesa; {5/98 AuerSoft - Simple Vesa 1.2 support for HiRes, extendible}
interface
const textcoords_in_pixels:boolean=true; keep_vram:boolean=false;
const allow_more_y:boolean=false; allow_more_col:boolean=false;

type dword=longint;
type ram=array [0..65519] of byte;
type words=array [0..32760] of word;
type mem_models=
 (TEXT_M, CGA_M, HGC_M, EGAVGA_M, MCGA_M, MODEX_M, RGB_M, YUV_M);
type modeinfoblock=record
 flags:word;  wa_flags,wb_flags:byte;  wgran,wsize,wa_seg,wb_seg:word;
 setfunc:pointer; x_by,x_res,y_res:word;
 x_cell,y_cell,planes,bpp,banks:byte;
 mem_model:mem_models;
 bank_size,images,one:byte;
 r_bits,r_shl,g_bits,g_shl,b_bits,b_shl,z_bits,color_inf:byte; end;
var vram:^ram; modeinfo:^modeinfoblock; windcall:pointer; vesaram:integer;
var currbase,currend:word; currpage:word;
var modelist: array [0..255] of word;

function  VESA_INIT(xwish,ywish,bppix:word; model:mem_models):boolean;
function  VESA_MAKE_MODEX:boolean;
function  VESA_SET_X_BUF(bonus:word):word; {Antwort: Y Bonus}
procedure VESA_SET_POS(xleftofs:longint; yupper:integer);
function  VESA_X:word;
function  VESA_X_BY:word;
function  VESA_Y:word;
function  VESA_Y_BASE:word;
function  VESA_SET_Y_BASE(y:word):boolean; {True, falls Page wechselte}
procedure VESA_SET_PAGE64(pgnum:word);
procedure VESA_END;

implementation
uses dos;
type maininfoblock=record idval:dword; vers:word; oem:^ram;
 capa:dword; modes:^words; ramsize:word; end;
var infoblock:array [0..255] of byte;
 maininfo:^maininfoblock; regs:registers;
var vesa_detected,fake_x:boolean; oldmode:byte; modelist2:^words;
var xpixels,ypixels,xbytes:word; windowfunc:pointer; retf:byte;
var twowinds,usewinds:boolean; granular:longint; granlines:word;

function VESA_INIT(xwish,ywish,bppix:word; model:mem_models):boolean;
var cnt,textx,texty:word; found,local_ok:boolean;
begin cnt:=0; found:=false; modeinfo:=@infoblock;
repeat local_ok:=true;
{ES, DI noch ok} regs.ax:=$4f01; regs.cx:=modelist[cnt]; intr($10,regs);
if (regs.ax=$004f) and ((modeinfo^.flags and $b)=$b) and
 (modeinfo^.mem_model=model) and
 (modeinfo^.one=1) then with modeinfo^ do begin
 {da, aktivierbar, farbig, Infos vollstndig, Model ok}
 if (mem_model=TEXT_M) then
  begin {Text}
   if (flags and $14)<>4 then local_ok:=false;
   {Text soll TTY haben und Text sein}
   if textcoords_in_pixels=true then
    begin textx:=xwish div x_cell; texty:=ywish div y_cell; end else
    begin textx:=xwish; texty:=ywish; end;
   if (x_res=textx) and (y_res=texty) and local_ok then found:=true;
  end else begin {Grafik}
   if (flags and $10)=0 then local_ok:=false; {keine Grafik}
   if (bppix=bpp) or ((bpp>bppix) and (bpp>=15)) then begin
    if (xwish<>x_res) or (ywish>y_res) or
     ((allow_more_y=false) and (y_res>ywish)) or
     ((allow_more_col=false) and (bpp>bppix)) then local_ok:=false;
    {Modi sollten nach Auflsung und Farben sortiert sein}
   end else local_ok:=false;
   if local_ok then found:=true;
  end;
end; if not found then inc(cnt);
until (found=true) or (modelist[cnt]=$ffff);
if found then begin
 regs.ax:=$4f02; regs.bx:=modelist[cnt]; intr($10,regs);
 if regs.ax<>$004f then found:=false else begin
 xpixels:=modeinfo^.x_res;
 ypixels:=modeinfo^.y_res;
 if (model=TEXT_M) and (textcoords_in_pixels=true) then begin
  xpixels:=xpixels*modeinfo^.x_cell;
  ypixels:=ypixels*modeinfo^.y_cell;
 end;
 xbytes:=modeinfo^.x_by;
 usewinds:=true; twowinds:=false;
 if (modeinfo^.wa_flags and 1)=0 then usewinds:=false;
 if (modeinfo^.wa_flags and 7)=7 then twowinds:=false else
  twowinds:=true; {Vereinfachte R/W-Fensterauswahl!}
 if twowinds and (modeinfo^.wa_seg<>modeinfo^.wb_seg) then usewinds:=false;
  {Vereinfacht}
 if usewinds then with modeinfo^ do begin
  vram:=ptr(wa_seg,0);
   regs.ax:=$4f06; regs.bx:=1; regs.cx:=0; regs.dx:=0; intr($10,regs);
   xbytes:=regs.bx; {Bytes per logical Scan Line in 8086-RAM}
  granular:=1024; granular:=granular*wgran; granlines:=granular div xbytes;
  vram:=ptr($a000,0);
  currbase:=$ffff; {erzwinge set} if VESA_SET_Y_BASE(0) then;
 end else begin
  if model=TEXT_M then vram:=ptr($b800,0) else vram:=ptr($a000,0);
  currbase:=0; currend:=$ffff; VESA_SET_PAGE64(0);
 end; {no windows}
 regs.ax:=$4f06; regs.bx:=1; regs.cx:=0; regs.dx:=0; intr($10,regs);
 xbytes:=regs.bx; {Bytes per logical Scan Line in 8086-RAM}
 if modeinfo^.setfunc<>NIL {NIL=0} then windcall:=modeinfo^.setfunc
  else windcall:=@retf;
end; {gesetzt} end; {found}
VESA_INIT:=found;
end;

function VESA_MAKE_MODEX:boolean; begin
if modeinfo^.mem_model<>MCGA_M then VESA_MAKE_MODEX:=false else begin
 port[$3d4]:=$14; port[$3d5]:=port[$3d5] and not($40); {DWord off}
 port[$3c4]:=$04; port[$3c5]:=(port[$3c5] or 4) and not(8); {lin., no chain4}
 port[$3d4]:=$17; port[$3d5]:=port[$3d5] or $40; { $e3/ ((or $43) and $77) }
  { $80 IRQ $40 Wordmode, $20 64k-Wrap $8 cntby2(for txt) }
  { 2 Dis. HGC-Compat 1 Dis. CGA-Compat }
 {...portw[$3ce]:=$0f07;...}
fake_x:=true; VESA_MAKE_MODEX:=true; end; end;

function VESA_SET_X_BUF(bonus:word):word; {Antwort: Y Bonus}
begin
 regs.ax:=$4f06; regs.bx:=0; regs.cx:=modeinfo^.x_res+bonus; regs.dx:=0;
 intr($10,regs); xbytes:=regs.bx; xpixels:=regs.cx;
 VESA_SET_X_BUF:=regs.dx-modeinfo^.y_res;
end;

procedure VESA_SET_POS(xleftofs:longint; yupper:integer); begin
 if xleftofs<0 then xleftofs:=0; if yupper<0 then yupper:=0;
 if xleftofs>=xpixels then begin
  inc(yupper,xleftofs div xpixels); xleftofs:=xleftofs mod xpixels; end;
 regs.ax:=$4f07; regs.bx:=0; regs.cx:=xleftofs; regs.dx:=yupper;
 intr($10,regs);
end;

function VESA_X:word; begin VESA_X:=xpixels; end;
function VESA_X_BY:word; begin
 if fake_x then VESA_X_BY:=xbytes shr 2 else VESA_X_BY:=xbytes; end;
function VESA_Y:word; begin VESA_Y:=ypixels; end;
function VESA_Y_BASE:word; begin VESA_Y_BASE:=currbase; end;

function VESA_SET_Y_BASE(y:word):boolean; var tmp,tmp2:longint; begin
if (y>=currbase) and (y<=currend) then VESA_SET_Y_BASE:=false
else begin tmp:=longint(xbytes)*longint(y);
  tmp2:=tmp mod granular; vram:=ptr(seg(vram^[0]),tmp2);
  tmp:=tmp div granular; currbase:=y; currend:=currbase+granlines;
  currpage:=$ffff and tmp;
  if windcall=@retf then begin
   regs.ax:=$4f05; regs.bx:=0; regs.dx:=tmp div granular; intr($10,regs);
   if twowinds then begin regs.ax:=$4f05; regs.bx:=1; intr($10,regs); end;
  end else begin
   inline($bb/>0 {mov bx,0}/ $8b/$16/>currpage {mov dx,currpage}/
    $3e/$ff/$1e/>windcall {callfar ds:windcall});
   if twowinds then inline($bb/>1 {...1}/ $3e/$ff/$1e/>windcall);
  end;
VESA_SET_Y_BASE:=true; end; {change} end;

procedure VESA_SET_PAGE64(pgnum:word); var tmp:longint; begin
 tmp:=64; tmp:=tmp*pgnum; tmp:=tmp div (granular shr 10); currpage:=tmp;
 inline($bb/>0 {mov bx,0}/ $8b/$16/>currpage {mov dx,currpage}/
  $3e/$ff/$1e/>windcall {callfar ds:windcall});
 if twowinds then inline($bb/>1/ $3e/$ff/$1e/>windcall);
end;

procedure VESA_END; begin regs.al:=oldmode; regs.ah:=0; intr($10,regs); end;

{main} var stri:word;
begin vesa_detected:=false;
regs.es:=seg(infoblock); regs.di:=ofs(infoblock); maininfo:=@infoblock[0];
regs.ax:=$4f00; intr($10,regs); if regs.ax=$004f then vesa_detected:=true;
if vesa_detected then with maininfo^ do begin
 if idval<>$41534556 {VESA} then vesa_detected:=false;
 if (hi(vers)<2) then if (hi(vers)<1) or (lo(vers)<2) then
  vesa_detected:=false;
end;
if not(vesa_detected) then begin
 writeln('No VESA 1.2 or better found!'); halt(1);
end {Suche nach VGA und Ersatz von Hand fr VGA-Modi wre denkbar!}
else begin
 vesaram:=64*maininfo^.ramsize;
 writeln('VESA ok, VRAM=',vesaram,'K');
 stri:=0; while maininfo^.oem^[stri]<>0 do
  begin write('',chr(maininfo^.oem^[stri])); inc(stri); end;
 writeln;
 modelist2:=@maininfo^.modes^[0];
 stri:=0;
 while (modelist2^[stri]<>$ffff) and (stri<250) do
  begin modelist[stri]:=modelist2^[stri]; inc(stri); end;
 modelist[stri]:=$ffff;
 { Modelist copying added 2004 - some VESA BIOSes return modelist }
 { in the int 10.4f00 USER BUFFER instead of having it in ROM...! }
end;
regs.ax:=$f00; intr($10,regs); oldmode:=regs.al;
retf:=$cb; windcall:=@retf; fake_x:=false;
end.
